=== unit_tests/c_bindings/CMakeLists.txt ===
# collect all tests in current folder
fetch_x86_tests(. LABELS unittest_x86)
fetch_gpu_tests(. LABELS unittest_cuda)
