=== debian/changelog ===
gridtools (1.0.2-2) unstable; urgency=medium

  * Reupload with source upload
  * Standards-Version: 4.4.1.0

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 30 Dec 2019 08:14:40 +0000

gridtools (1.0.2-1) unstable; urgency=medium

  * Initial release. (Closes: #935264)
  * re-done with Apache license referenced in d/copyright

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 08 Dec 2019 15:26:03 +0000
