## gridtools 1.1.2

=== debian/changelog ===
gridtools (1.1.2-1) unstable; urgency=medium

  * New upstream release
  * Add mipsel to list of non -march=native architectures
  * Don't include cpp_bindgen as it requires a pull from git external
    project

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 08 Jan 2020 09:16:10 +0000

gridtools (1.0.2-3) unstable; urgency=medium

  * Use ecbuild now instead of cmake
  * Set -DGT_ENABLE_BACKEND_X86-Off -DGT_ENABLE_BACKEND_NAIVE=Off to ensure
    -march=native not used on archs where it FTBFS
  * Drop ${shlibs:Depends} in bin package as it provides static archives only
  * Fix homepage to gridtools.github.io
  * libgridtools-dev requires mpi, ecbuild to compile

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 05 Jan 2020 12:54:10 +0000
